/*
 *	FarSync X.25 sockets driver for Linux
 *
 *	Copyright (C) 2000-2002 FarSite Communications Ltd.
 *	www.farsite.co.uk
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it as you wish.
 *
 *	File:	fsx25sockapi.h
 *	Author:	K. P. Curtis    	<kevin.curtis@farsite.co.uk>
 */

/*	Revision History
 *	$Log: fsx25sockapi.h,v $
 *	Revision 1.1  2003/05/01 15:16:12  robw
 *	Initial checkin
 *	
 *	Revision 1.5  2002/09/27 10:48:48  kevinc
 *	Additional IOCTL's and structures for patch release
 *	
 *	Revision 1.4  2002/08/23 12:53:06  kevinc
 *	Removed GPL licensing so users are not bound
 *	
 *	Revision 1.3  2002/08/16 10:44:43  kevinc
 *	New IOCTL's added during beta-2 phase
 *	
 *	Revision 1.2  2002/07/12 15:06:23  kevinc
 *	Added ioclt for setting cause and diagnostic
 *	
 *	Revision 1.1  2002/07/03 09:08:34  kevinc
 *	New file for sockets api with extentions to Kernel X.25 features
 *	
 */
#ifndef _FSX25SOCKAPI_H
#define _FSX25SOCKAPI_H

//#define FSK_HP2FS   /* For compatability with HPUX X.25 */

/*
 * New IOCTL's for our driver
 */
#define	SIOCX25GADAPTER	      (SIOCPROTOPRIVATE + 7)
#define	SIOCX25SADAPTER	      (SIOCPROTOPRIVATE + 8)
#define SIOCX25GRAWFAC        (SIOCPROTOPRIVATE + 9)
#define SIOCX25SRAWFAC        (SIOCPROTOPRIVATE + 10)
#define SIOCX25SCAUSEDIAG     (SIOCPROTOPRIVATE + 11)
#define SIOCX25SDELAYACPT     (SIOCPROTOPRIVATE + 12)
#define SIOCX25SSENDACPT      (SIOCPROTOPRIVATE + 13)
#define SIOCX25SLOCALNUA      (SIOCPROTOPRIVATE + 14)
#define SIOCX25GLOCALNUA      (SIOCPROTOPRIVATE + 15)
#define SIOCX25GCONSTATE      (SIOCPROTOPRIVATE + 16)
#define SIOCX25GIFSTATE       (SIOCPROTOPRIVATE + 17)
#define SIOCX25GNEXTMSGST     (SIOCPROTOPRIVATE + 18)
#define SIOCX25GRAWFACVAL     (SIOCPROTOPRIVATE + 19)
#define SIOCX25SRAWFACVAL     (SIOCPROTOPRIVATE + 20)
#define SIOCX25SCLEARUSERDATA (SIOCPROTOPRIVATE + 21)

/*
 * New socket options for our driver
 */
#define	X25_MBITINCL		X25_QBITINCL+1

#define FSK_MAX_FAC_LENGTH 200

/*
 * Connection states
 */
#define FSK_CLOSED       0
#define FSK_CONNECTING   1
#define FSK_CONNECTED    2

/*
 * Interface states
 */
#define FSK_IF_X25_UP    0
#define FSK_IF_X25_DOWN  1
#define FSK_IF_UNDEFINED 0xff

#define FSK_MAX_LINES 4
struct fsk_if_state {
  int adapter;
  int line[FSK_MAX_LINES];
};

/*
 * Next message status
 */
struct fsk_msg_stat {
  int x25_msg_size;
  int x25_msg_flags;
};

#define FSK_ADPT_0       0
#define FSK_ADPT_1       1
#define FSK_ADPT_2       2
#define FSK_ADPT_3       3

#define FSK_LINE_0       0
#define FSK_LINE_1       1
#define FSK_LINE_2       2
#define FSK_LINE_3       3
#define FSK_LINE_ANY     4

struct fsk_port_info {
  int adapter;
  int line;
};

#define FSK_FAC_DONT_VALIDATE 0
#define FSK_FAC_CALL_REQUEST  1
#define FSK_FAC_CALL_ACCEPT   2
#define FSK_FAC_CLEAR_REQUEST 3

struct fsk_raw_facs {
  int length;
  unsigned char data [FSK_MAX_FAC_LENGTH];
};

struct fsk_raw_facs_val {
  int length;
  int type;
  unsigned char data [FSK_MAX_FAC_LENGTH];
};


/*
 * bit position's in the users control byte for the m and the q bit
 */
#define QBIT_POS         0
#define MBIT_POS         1
#define QBIT_VAL         1
#define MBIT_VAL         2

#endif
